<?php
/*
 * WPGear. Import Excel to Gravity Forms PRO
 * admin.php
 */

	/* Admin Console - Styles.
	----------------------------------------------------------------- */	
	function GFXLImportPro_admin_style ($hook) {
		global $GFXLImportPro_plugin_url;
		
		$screen = get_current_screen();
		$screen_base = $screen->base;		
		
		if ( $screen_base == 'toplevel_page_gf_edit_forms' || $screen_base == 'gf-excel-import-pro/includes/admin/options') {
			wp_enqueue_style ('gfxl_import_pro_adminstyle', $GFXLImportPro_plugin_url .'/includes/admin/admin-style.css');
		}	
	}
	add_action ('admin_enqueue_scripts', 'GFXLImportPro_admin_style' );	

	/* Registering Styles with Gravity Forms when running on "no-conflict mode"
	----------------------------------------------------------------- */
	function GFXLImportPro_register_safe_styles_GF( $styles ){
		$styles[] = "gfxl_import_pro_adminstyle";
		return $styles;
	}
	add_filter('gform_noconflict_styles', 'GFXLImportPro_register_safe_styles_GF' );
	
	/* Create plugin SubMenu
	----------------------------------------------------------------- */		
	function GFXLImportPro_create_menu() {
		add_options_page(
			__( 'Import Excel to Gravity Forms PRO', 'textdomain' ),
			__( 'Import Excel to Gravity Forms PRO', 'textdomain' ),
			'publish_posts',
			'gf-excel-import-pro/includes/admin/options.php',
			''
		);
	}
	add_action('admin_menu', 'GFXLImportPro_create_menu');	

	/* Add Metabox Excel-Import. Gravity Forms -> Page: Settings.
	----------------------------------------------------------------- */	
	add_filter('gform_form_settings', 'GFXLImportPro_add_metabox', 10, 2);
	function GFXLImportPro_add_metabox($form_settings, $form){		
        // В старших версиях GF изменен формат Всплывающих Подсказок. Поэтому, делаем универсальный вариант. Без изысков.
		
		if (isset($form['gfxl_import'])) {
			// Следы обычной версии "Import Excel to Gravity Forms"
			if (isset($form['gfxl_import_pro'])) {
				$Options_GFXLImport = (isset($form['gfxl_import_pro']) && $form['gfxl_import_pro'] == 'on') ? 'checked' : '';
			} else {
				// Наследуем Настройки
				$Options_GFXLImport = (isset($form['gfxl_import']) && $form['gfxl_import'] == 'on') ? 'checked' : '';
			}
		} else {
			$Options_GFXLImport = (isset($form['gfxl_import_pro']) && $form['gfxl_import_pro'] == 'on') ? 'checked' : '';
		}
		
		$form_settings['Excel Import']['gfxl_import_pro'] = '
			<tr>
				<th>
					Excel Import PRO <a href=\'#\' onclick=\'return false;\' onkeypress=\'return false;\' class=\'gf_tooltip tooltip tooltip_form_form_button_gfxl_import_pro\' title=\'Bulk Import of Records from Excel (CSV) files with Validation and Internal Logic support.\'><i class=\'fa fa-question-circle\'></i></a>
				</th>
				<td>
					<input type="checkbox" id="form_button_gfxl_import_pro" name="gfxl_import_pro" ' .$Options_GFXLImport . '>
					<label for="form_button_gfxl_import_pro" class="inline"> Enable Excel Import</label>
				</td>
			 </tr>
		';	
		
		return $form_settings;
	}

	/* Save MetaBox Excel-Import. Gravity Forms -> Page: Settings.
	----------------------------------------------------------------- */
	add_filter('gform_pre_form_settings_save', 'GFXLImportPro_save_metabox');
	function GFXLImportPro_save_metabox($form) {		
		
        $form['gfxl_import_pro'] = rgpost( 'gfxl_import_pro' );

        return $form;
	}	