<?php
/*
 * WPGear. Import Excel to Gravity Forms PRO
 * ajax_processing.php
 */

	$Mode 		= isset($_REQUEST['mode']) ? sanitize_text_field($_REQUEST['mode']) : null;
	$GF_Form_ID = isset($_REQUEST['gf_id']) ? sanitize_text_field ($_REQUEST['gf_id']) : null;
	$GF_Fields 	= isset($_REQUEST['fields']) ? $_REQUEST['fields'] : null;	
	
	$Current_User = wp_get_current_user();
	$User_Name = $Current_User->display_name;
	
	$Result = false;

	$Error = false;
	$Errors_Msg = array();
	
	// PRO. Get_Template
	if ($Mode == 'get_template') {
		$GF_Form = GFAPI::get_form( $GF_Form_ID );
		$GF_Fields = $GF_Form['fields'];	
	
		if ($GF_Fields) {
			global $GFXLImport_ValueType_for_Select;
			
			$Template_Header = array();
			$Template_FieldID = array();
			$Template_Type = array();
			$Template_CellComment = array();
			$Template_Ranges = array();			
			
			foreach ($GF_Fields as $Field) {
				$Field_Type = $Field['type'];
				$Field_ID = $Field['id'];
				$Field_label = $Field['label'];
				$Field_IsRequired = $Field['isRequired'];
				$Field_Visibility = $Field['visibility'];
				$Field_InputMask = $Field['inputMask'];
				$Field_InputMaskValue = $Field['inputMaskValue'];
				$Field_InputType = $Field['inputType'];
				$Field_DateFormat = $Field['dateFormat'];
				$Field_DefaultValue = $Field['defaultValue'];
				$Field_ConditionalLogic = $Field['conditionalLogic'];
				$Field_MaxLength = $Field['maxLength'];
				$Field_RangeMin	= $Field['rangeMin'];	
				$Field_RangeMax	= $Field['rangeMax'];				
				$Field_CalculationFormula = $Field['calculationFormula'];
				$Field_CalculationRounding = $Field['calculationRounding'];
				$Field_EnableCalculation = $Field['enableCalculation'];
				$Field_DisplayOnly = $Field['displayOnly'];
				$Field_Choices = $Field['choices'];
				$Field_IsReadOnly = $Field['gwreadonly_enable'];

				if (in_array($Field_Type, array ('text', 'textarea', 'number', 'email', 'date', 'select', 'radio', 'checkbox', 'multiselect') )) {
					if (!$Field_IsReadOnly) {
						// No ReadOnly
						if ($Field_EnableCalculation) {
							// В Поле встроено Вычисление.
						} else {
							if ($Field_Visibility == 'visible') {
								// No Hidden. No Administrative.
								$Template_FieldID[] = $Field_ID;								
								
								if ($Field_Type == 'date') {
									$Template_Type[] = $Field_Type .': ' .$Field_DateFormat;
								} else {
									$Template_Type[] = $Field_Type;
								}
								
								$Template_Header[] = $Field_label;
								
								$Template_CellComment[] = $Field_Choices;

								$Template_Ranges[] = array (
									'Min' => $Field_RangeMin,
									'Max' => $Field_RangeMax,
								);
							}
						}							
					}
				}		
			}
			
			if ($Template_Header) {
				if (! class_exists('PHPExcel')) {
					global $GFXLImportPro_plugin_dir;
					include_once($GFXLImportPro_plugin_dir .'/lib/phpExcel_7.4/PHPExcel.php');
				}
				
				$xls = new PHPExcel();		

				$xls->getProperties()->setTitle("Template for GF Import");
				$xls->getProperties()->setSubject("GF_Form_ID: $GF_Form_ID");
				$xls->getProperties()->setCreator($User_Name);
				$xls->getProperties()->setCompany("WPGear");
				$xls->getProperties()->setCategory("Back-Office");			
				$xls->getProperties()->setDescription("1. Enter data into the table \r\n2. Save in CSV format \r\n3.Upload via Import");
				$xls->getProperties()->setCreated(date("Y.m.d"));

				$xls->setActiveSheetIndex(0);
				$sheet = $xls->getActiveSheet();
				$sheet->setTitle('Template');		
				
				// $sheet->setCellValue("A2", $Note_About_DateRange);
				$sheet->getColumnDimension("A")->setWidth(1.0);
				
				$Start_Column 	= 'A';	// Начинать надо с А, чтбы не было конфликтов индексов массивов данных.
				$Start_Row 		= 1;
				$Start_Cell 	= $Start_Column .$Start_Row;
								
				$sheet->fromArray($Template_FieldID, null, $Start_Cell);
				
				$Start_Row 		= 2;
				$Start_Cell 	= $Start_Column .$Start_Row;			
				$sheet->fromArray($Template_Type, null, $Start_Cell);
				
				$Start_Row 		= 3;
				$Start_Cell 	= $Start_Column .$Start_Row;			
				$sheet->fromArray($Template_Header, null, $Start_Cell);
				
				$Last_Column 	= $sheet->getHighestDataColumn();
				$Last_Row 		= $sheet->getHighestDataRow();

				$ColumnIterator = $sheet->getColumnIterator();	

				// Стили форматирования ячеек
				$Borders_Thin = array(
					'borders'=>array(
						'outline' => array(
							'style' => PHPExcel_Style_Border::BORDER_THIN,
							'color' => array('rgb' => '000000')
						),
					)
				);
				
				// Постобработка.
				$i = 0;
				foreach( $ColumnIterator as $Column ) {
					$Column_Index = $Column->getColumnIndex();
					
					// AutoSize Column 
					$sheet->getColumnDimension( $Column_Index )->setAutoSize(true);
					
					// Выравниваем по центру
					$Start_Row = 1;			
					$sheet->getStyle($Column_Index .($Start_Row) .':' .$Column_Index .($Start_Row + 3))->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
					
					// Вставляем Комментарии для некоторых Типов Полей (Не работает в Excel5. Используем далее Excel2007)
					$Start_Row = 2;
					$Cell = $Column_Index .$Start_Row;
					
					if ($Template_Type[$i] == 'radio' || $Template_Type[$i] == 'select' || $Template_Type[$i] == 'multiselect' || $Template_Type[$i] == 'checkbox' || $Template_Type[$i] == 'number') {
						$CellComment 	= '';
						$CellSample 	= '';
						
						if ($Template_Type[$i] == 'number') {
							// Поля типа: Number
							if ($Field_EnableCalculation) {
								// В Поле встроено Вычисление.
							} else {
								if ($Template_Ranges[$i]) {
									$Range_Min = $Template_Ranges[$i]['Min'];
									$Range_Max = $Template_Ranges[$i]['Max'];
								
									if ($Range_Min) {
										$CellComment .= "Min: " .$Range_Min ."\r\n";
									}
									
									if ($Range_Max) {
										$CellComment .= "Max: " .$Range_Max ."\r\n";
									}

									if ($CellComment) {
										$Field_Choices = $Template_Ranges[$i];
									}
								}								
							}
						} else if ($Template_Type[$i] == 'checkbox') {	
							// Поля типа: CheckBox
							$Field_Choices = $Template_CellComment[$i];
							
							foreach ($Field_Choices as $Field_Choice) {
								// Подсказка только с Названием.
								if ($GFXLImport_ValueType_for_Select == 'name') {
									// Подсказка только с Названием.
									$CellSample .= $Field_Choice['text'] .',';
									$CellComment .= $Field_Choice['text'] ."\r\n";									
								} else {
									// Подсказка со Значением и Названием.
									$CellSample .= $Field_Choice['value'] .',';
									$CellComment .= $Field_Choice['value'] .' => ' .$Field_Choice['text'] ."\r\n";
								}
							}
							
							$CellSample = substr($CellSample, 0, -1);
							$CellSample = "sample: " .$CellSample ."\r\n";						
							
							$CellComment = $CellSample .$CellComment;
							
							$Field_Choices[] = 'nothing';	// Line + 1							
						} else if ($Template_Type[$i] == 'multiselect') {
							// Поля типа: Multiselect
							$Field_Choices = $Template_CellComment[$i];
							
							foreach ($Field_Choices as $Field_Choice) {
								// Подсказка только с Названием.
								if ($GFXLImport_ValueType_for_Select == 'name') {
									// Подсказка только с Названием.
									$CellSample .= $Field_Choice['text'] .',';
									$CellComment .= $Field_Choice['text'] ."\r\n";									
								} else {
									// Подсказка со Значением и Названием.
									$CellSample .= $Field_Choice['value'] .',';
									$CellComment .= $Field_Choice['value'] .' => ' .$Field_Choice['text'] ."\r\n";
								}
							}
							
							$CellSample = substr($CellSample, 0, -1);
							$CellSample = "sample: " .$CellSample ."\r\n";						
							
							$CellComment = $CellSample .$CellComment;
							
							$Field_Choices[] = 'nothing';	// Line + 1
						} else {
							// Прочие Поля
							$Field_Choices = $Template_CellComment[$i];
							
							foreach ($Field_Choices as $Field_Choice) {
								// Подсказка только с Названием.
								if ($GFXLImport_ValueType_for_Select == 'name') {
									// Подсказка только с Названием.
									$CellComment .= $Field_Choice['text'] ."\r\n";									
								} else {
									// Подсказка со Значением и Названием.
									$CellComment .= $Field_Choice['value'] .' => ' .$Field_Choice['text'] ."\r\n";
								}								
							}	
						}						
												
						if ($CellComment) {
							$sheet->getComment($Cell)->getText()->createTextRun($CellComment);
							$sheet->getComment($Cell)->setWidth('300pt');
							$sheet->getComment($Cell)->setHeight(count($Field_Choices) * 15 .'pt');
						}
					}				

					// Форматируем Заголовки
					$Start_Row = 3;
					$Cell = $Column_Index .$Start_Row;				
					$sheet->getStyle($Cell)->getFont()->setBold(true);
					$sheet->getStyle($Cell)->applyFromArray($Borders_Thin);				

					$i = $i + 1;	
				}

				if ($GFXLImport_ValueType_for_Select == 'name') {
					$File_Name = "template_import_gf_$GF_Form_ID" ."_N.xlsx";
				} else {
					$File_Name = "template_import_gf_$GF_Form_ID" ."_V.xlsx";
				}

				// ob_end_clean();
				
				header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
				header('Content-Disposition: attachment;filename=' .$File_Name);
				header('Cache-Control: max-age=0');			

				$Upload_Dir = wp_get_upload_dir();
				$Upload_Dir_Path = $Upload_Dir['basedir'] .'/' .$File_Name;	// Папка Uploads
				
				$Upload_URL_Path = $Upload_Dir['baseurl'] .'/' .$File_Name;	// Папка Uploads
				
				// $writer = new PHPExcel_Writer_Excel2007($xls);
					$writer = PHPExcel_IOFactory::createWriter($xls, 'Excel2007');
					$writer->save($Upload_Dir_Path);	
				
				// $objWriter = new PHPExcel_Writer_Excel5($xls);
					// $writer = PHPExcel_IOFactory::createWriter($xls, 'Excel5');				
					// $writer->save($File_Name .'.xls');	
				
				// $writer->save('zzz.xls');				
			}			
		}			
		
		$Result = true;
	}

	// Get_Fields and Validations.
	if ($Mode == 'get_fields') {
		if ($GF_Fields) {
			global $GFXLImport_ValueType_for_Select;
			
			foreach ($GF_Fields as &$Item) {
				$Field_ID 	= $Item['id'];
				$Field_Arg 	= $Item['value'];
				
				$Item['error'] = false;
				$ErrorMsg = '';
				
				if ($Field_ID) {					
					$Field = GFAPI::get_field ( $GF_Form_ID, $Field_ID );

					$Field_Type 	= $Field['type'];
					$Field_label 	= $Field['label'];
					$Field_Choices 	= $Field['choices'];
					$Field_Inputs	= $Field['inputs'];					
					
					$Item['input_id'] 	= 'input_' .$GF_Form_ID .'_' .$Field_ID;
					$Item['type'] 		= $Field_Type; 
					$Item['choice'] 	= '';
					
					if (in_array ($Field_Type, array ('select','multiselect','radio','checkbox','number') )) {						
						// Получаем Значения.
						if (isset($Field_Arg)) {
							$ChoiceError = true;
					
							if ($Field_Type == 'checkbox') {
								// Обработка Полей типа: CheckBox
								$Field_Arg = explode(",", $Field_Arg);					
											
								$Field_Choices_Flat = [];
								$Choices_Value = [];
								$Choices_Index = [];

								$ChoiceError = false;	

								foreach ($Field_Choices as $key => $Field_Choice) {
									if ($GFXLImport_ValueType_for_Select == 'name') {
										// Названия
										$Field_Choices_Flat[] = $Field_Choice['text'];

										foreach ($Field_Arg as $Arg) {
											if ($Arg == $Field_Choice['value']) {
												$Choices_Value[] = $Field_Choice['text'];
												$Choices_Index[] = 'choice_' .$GF_Form_ID .'_' .$Field_ID .'_' .($key + 1);				
											}
										}		
									} else {
										// Значения
										$Field_Choices_Flat[] = $Field_Choice['value'];
										
										foreach ($Field_Arg as $Arg) {
											if ($Arg == $Field_Choice['value']) {
												$Choices_Value[] = $Field_Choice['text'];
												$Choices_Index[] = 'choice_' .$GF_Form_ID .'_' .$Field_ID .'_' .($key + 1);				
											}
										}	
									}
								}

								foreach ($Field_Arg as $key => $value) {		
									if (! in_array ($value, $Field_Choices_Flat)) {
										$ChoiceError = true;	
									}
								}	

								$Item['choice'] 	= $Choices_Value;
								$Item['value'] 		= json_encode($Field_Arg);	
								$Item['input_id'] 	= $Choices_Index;
							} else if ($Field_Type == 'select') {
								// Обработка Полей типа: Select
								foreach ($Field_Choices as $Field_Choice) {									
									if ($GFXLImport_ValueType_for_Select == 'name') {
										// Названия
										if ($Field_Arg == $Field_Choice['text']) {									
											$Item['value'] 		= $Field_Choice['value'];									
											
											$ChoiceError = false;
										}
									} else {
										// Значения
										if ($Field_Arg == $Field_Choice['value']) {	
											$Item['choice'] 	= $Field_Choice['text'];										
											$Item['value'] 		= $Field_Choice['value'];									
											
											$ChoiceError = false;
										}
									}									
								}								
							} else if ($Field_Type == 'radio') {
								// Обработка Полей типа: Radio
								$i = 0;								
								foreach ($Field_Choices as $Field_Choice) {
									if ($GFXLImport_ValueType_for_Select == 'name') {
										// Названия
										if ($Field_Arg == $Field_Choice['text']) {									
											$Item['value'] 		= $Field_Choice['value'];
											$Item['input_id'] 	= 'choice_' .$GF_Form_ID .'_' .$Field_ID .'_' .$i;
											
											$ChoiceError = false;
										}
									} else {
										// Значения
										if ($Field_Arg == $Field_Choice['value']) {
											$Item['choice'] 	= $Field_Choice['text'];											
											$Item['value'] 		= $Field_Choice['value'];	
											$Item['input_id'] 	= 'choice_' .$GF_Form_ID .'_' .$Field_ID .'_' .$i;
											
											$ChoiceError = false;
										}
									}

									$i = $i + 1;									
								}
							} else if ($Field_Type == 'multiselect') {	
								// Обработка Полей типа: MultiSelect
								$Field_Arg = explode(",", $Field_Arg);					
											
								$Field_Choices_Flat = [];
								$Choices = [];
								
								$ChoiceError = false;	
								foreach ($Field_Choices as $Field_Choice) {
									if ($GFXLImport_ValueType_for_Select == 'name') {
										// Названия
										$Field_Choices_Flat[] = $Field_Choice['text'];
									} else {
										// Значения
										$Field_Choices_Flat[] = $Field_Choice['value'];
										
										foreach ($Field_Arg as $key => $value) {
											if ($value == $Field_Choice['value']) {
												$Choices[] = $Field_Choice['text'];
											}
										}	
									}
								}

								foreach ($Field_Arg as $key => $value) {		
									if (! in_array ($value, $Field_Choices_Flat)) {
										$ChoiceError = true;	
									}
								}	
						
								$Item['choice'] 	= $Choices;
								$Item['value'] 		= json_encode($Field_Arg);								
							} else if ($Field_Type == 'number') {	
								// Обработка Полей типа: Number
								$Field_RangeMin	= $Field['rangeMin'];	
								$Field_RangeMax	= $Field['rangeMax'];	
								
								if (is_numeric($Item['value'])) {
									$Field_Value = + $Item['value'];
									
									$ChoiceError = false;
									
									// Check RangeMin
									if (is_numeric($Field_RangeMin)) {
										//Convert Str to Num.
										$Field_RangeMin = + $Field_RangeMin;										
										
										if ($Field_Value >= $Field_RangeMin) {
											// RangeMin OK
										} else {
											$ChoiceError = true;
											$ErrorMsg = 'Value < Min';
										}
									}
									
									// Check RangeMax
									if (is_numeric($Field_RangeMax)) {
										//Convert Str to Num.
										$Field_RangeMax = + $Field_RangeMax;
										
										if ($Field_Value <= $Field_RangeMax) {
											// RangeMax OK
										} else {
											$ChoiceError = true;
											$ErrorMsg = 'Value > Max';
										}
									}									
								}
								
								$Item['choice'] = $Item['value'];
							} else {
								// Прочие Поля. Что было бы странно ))
								$Item['choice'] = $Item['value'];									
								
								if (Field_Choices) {
									$Item['choice'] = '';
									
									foreach ($Field_Choices as $Field_Choice) {
										if ($Field_Arg == $Field_Choice['text']) {									
											$Item['choice'] 	= $Field_Choice['text'];
											$Item['value'] 		= $Field_Choice['value'];									
											
											$ChoiceError = false;
										}					
									}									
								}
							}
							
							if ($ChoiceError) {
								$Error = true;
								
								if ($ErrorMsg == '') {
									$ErrorMsg = "Value: [$Field_Arg]";
								} else {
									$ErrorMsg = "Value: [$Field_Arg] ($ErrorMsg)";
								}
								
								$Item['error'] = true;
								$Item['error_msg'] = $ErrorMsg;
								
								$ErrorMsg = "Field_ID: $Field_ID " .$ErrorMsg;
								$Errors_Msg[] = trim($ErrorMsg);
							}
						}						
					} else {
						// Прочие Поля
						$Item['choice'] = $Item['value'];
					}					
				}
			}		
		}
		
		$Result = true;
	}

	// Save New Record.
	if ($Mode == 'save') {
		if ($GF_Form_ID && $GF_Fields) {
			$GF_Entry = array();

			$GF_Entry['form_id'] = $GF_Form_ID;			
			
			foreach ($GF_Fields as $Item) {	
				$Field_ID = $Item['id'];
				$Field_Value = stripslashes($Item['value']);
				
				$GF_Entry[$Field_ID] = $Field_Value;
			}		
			
			$entry_id = GFAPI::add_entry( $GF_Entry );
			
			if ($entry_id) {
				$GF_Fields = 'entry_id:' .$entry_id;
			} else {
				$GF_Fields = null;
			}		
		}
		
		$Result = true;
	}		

	$Obj_Request = new stdClass();
	$Obj_Request->status 	= 'OK';
	$Obj_Request->answer 	= $Result;
	$Obj_Request->file_link = $Upload_URL_Path;
	$Obj_Request->file_name = $File_Name;	
	$Obj_Request->fileds 	= $GF_Fields;
	$Obj_Request->error 	= $Error;
	$Obj_Request->error_msg	= $Errors_Msg;	

	wp_send_json($Obj_Request);    

	die; // Complete.